#include "biglb.h"
#ifdef __BORLANDC__
#pragma hdrstop
#endif

LPSTR dll_malloc(HWND hWnd,DWORD len)
{
  /* cast this FAR */
  LPSTR (FAR *page_table);
  LPSTR retval;
  WORD current_offset;
  WORD current_page;

  /* too long or too short for a page... */
  if (len > PAGESIZE || len == 0L)
        return NULL;
  page_table=(LPSTR FAR *)GetWindowLong(hWnd,GWL_PAGETABLE);
  current_page = GetWindowWord(hWnd,GWL_CURRENT_PAGE);
  current_offset = GetWindowWord(hWnd,GWL_CURRENT_OFFSET);
  if (page_table == NULL)
  {
    /* first call, allocate the page_table... */
    page_table = (LPSTR FAR *) 
        GlobalLock(GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,
         (DWORD) MAXPAGES * sizeof(LPSTR)));
    if (page_table == NULL)
      return NULL;
    current_offset = 0;
    current_page = 0;
    /* allocate the first page */
    if ((page_table[current_page] = (LPSTR)
          GlobalLock(GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,
          (DWORD) PAGESIZE))) == NULL)
      return NULL;
    retval = page_table[current_page];
    current_offset += (WORD) len;
  }
  else  /* some waisted space at the end of a page */
    if ((DWORD)current_offset+(DWORD)len > PAGESIZE)
    {
      /* allocate a new page... */
      if (++current_page == MAXPAGES)
        return NULL;
      current_offset = 0;
      if ((page_table[current_page] = (LPSTR)
         GlobalLock(GlobalAlloc(GMEM_MOVEABLE|GMEM_ZEROINIT,
                     (DWORD) PAGESIZE))) == NULL)
        return NULL;
      retval = page_table[current_page];
      current_offset += (WORD) len;
    }
    else
      {
        retval = &page_table[current_page][current_offset];
        current_offset += (WORD) len;
      }
  /* stash the updated values... */
  SetWindowLong(hWnd, GWL_PAGETABLE, (DWORD)page_table);
  SetWindowWord(hWnd, GWL_CURRENT_PAGE, current_page);
  SetWindowWord(hWnd, GWL_CURRENT_OFFSET, current_offset);
  return retval;
}

void dll_freeall(HWND hWnd)
{
  /* cast this FAR */
  LPSTR (FAR *page_table);
  WORD current_offset;
  WORD current_page;
  int i;
  GLOBALHANDLE gh;

  page_table=(LPSTR FAR *)GetWindowLong(hWnd,GWL_PAGETABLE);
  current_page = GetWindowWord(hWnd, GWL_CURRENT_PAGE);
  current_offset = GetWindowWord(hWnd, GWL_CURRENT_OFFSET);

  if (page_table == NULL) /* already freed */
        return;
  i = 0;
  while (page_table[i] != NULL && i < MAXPAGES)
  {
    gh = (GLOBALHANDLE)
             GlobalHandle(HIWORD(page_table[i++]));
    GlobalUnlock(gh);
    GlobalFree(gh);
  }
  gh=(GLOBALHANDLE)GlobalHandle(HIWORD((LPSTR)page_table));
  GlobalUnlock(gh);
  GlobalFree(gh);
  page_table = NULL;
  current_page = 0;
  current_offset = 0;
  /* stash the updated values... */
  SetWindowLong(hWnd, GWL_PAGETABLE,(LONG)page_table);
  SetWindowWord(hWnd, GWL_CURRENT_PAGE,current_page);
  SetWindowWord(hWnd, GWL_CURRENT_OFFSET,current_offset);
}


