/*
 *  shred.c: Shred a file so it cannot be undeleted
 *  Written by John N. Power - 16 Sep 92
 *  Compiler: Microsoft C 5.1 / Borland C 3.1
 */

#include <stdio.h>
#include <stdlib.h>
#include <io.h>
#include <memory.h>
#include <ctype.h>

main(int argc, char **argv)
{
    FILE *shredfile;            /* file to be shredded  */
    long filelen;               /* its length           */
    char buf[512];
    int i, numbufs;
    
    if (argc != 2)              /* check for single arg */
    {
        puts("usage: shred shredfile");
        exit(1);
    }
    
    printf("Do you really want to shred file: %s (Y/N)? ", argv[1]);
    if (tolower(getchar()) != 'y')
    {
        puts("Not shredding.");
        exit(1);
    }
    
    if ((shredfile = fopen(argv[1], "rb+")) == NULL)
    {
        printf("Unable to open file: %s\n", argv[1]);
        exit(1);
    }
    
    filelen = filelength(fileno(shredfile));
    if (filelen == -1L)         /* -1 means file length */
    {                           /* determination failed */
        puts("Operation failed.");
        fclose(shredfile);
        exit(1);
    }
    
    numbufs = (int) (filelen/512L); /* no. of buffers needed    */
    if ((int) (filelen % 512L))     /* to cover the file        */
        numbufs++;
    
    memset(buf, '\0', 512);     /* fill the file with nulls     */
    
    for (i = 0; i < numbufs; i++)
        fwrite(buf, 1, 512, shredfile); /* overwriting now      */
        
    fclose(shredfile);
    unlink(argv[1]);
    puts("Operation complete.");
    return 0;
}
